#pragma once
#include <luna/LinkedList.h>
#include <luna/RefString.h>
#include <ui/Canvas.h>
#include <ui/Color.h>
#include <ui/Rect.h>
#include <ui/ipc/Server.h>

struct Client;
struct Layer;

struct Window : public LinkedListNode<Window>
{
    ui::Rect surface;
    ui::Rect titlebar;
    u32* pixels;
    RefString name;
    RefString shm_path;
    bool dirty { false };
    Client* client;
    Layer* layer;
    int id;

    Window(ui::Rect, RefString&&);
    ~Window();

    void focus();

    void draw(ui::Canvas& screen);
};
